import path from "path";
import { LINE_8, MARKER_CROSS } from "./consts";

export const config = {
	ADDON_PATH: path.join(__dirname, "../../build/cv.node"),
	DEFAULT_LINE_TYPE: LINE_8,
	DEFAULT_THICKNESS: 1,
	DEFAULT_MARKER: MARKER_CROSS,
};

export type AddonConfig = typeof config;

export function getAddon() {
	return require(config.ADDON_PATH);
}

console.log(getAddon())

export function getConfig<N extends keyof AddonConfig>(name: N): AddonConfig[N] { return config[name]; }
export function setConfig<N extends keyof AddonConfig>(name: N, value: AddonConfig[N]) { config[name] = value; }

export function CVMat() { return getAddon().Mat; }
export function CVVideoCapture() { return getAddon().VideoCapture; }
export function CVUtil() { return getAddon().util; }
